MaxKey v 3.3.3 GA 2022/03/03 
    *(MAXKEY-220401) 网易企业邮箱单点登录支持
    *(MAXKEY-220402) Active Directory域控组织、账号同步优化
    *(MAXKEY-220403) OAuth及OIDC兼容 Authorization/authorization的bearer #I4VFYD(无双的英雄peerless_hero)
    *(MAXKEY-220404) 优化实时同步，增加RocketMQ支持
    *(MAXKEY-220405) IP地址转换为行政区域，后续增加异地登录风险通知
    *(MAXKEY-220406) 官方网站内容优化和完善
    *(MAXKEY-220407) 图片验证码可配置调整；支持数字和算术计算；长度80，高度40
    *(MAXKEY-220408) RSAUtils优化增加签名和验证功能，优化PEM生成器功能
    *(MAXKEY-220409) 管理端登录验证码高度不一致调整
    *(MAXKEY-220410) docker配置文件中DATABASE_HOST改为localhost
    *(MAXKEY-220411) 注册默认租户ID设置为1
    *(MAXKEY-220412) 增加LDAP账号映射功能，登录账号和LDAP账号可进行映射
    *(MAXKEY-220413) 日志功能优化
    *(MAXKEY-220414) 配置管理默认登录后地址
    *(MAXKEY-220415) 服务端删除对maxkey-client-sdk依赖
    *(MAXKEY-220416) 产品简短说明，添加badges标志，产品功能说明优化
    *(MAXKEY-220417) 增加用户、机构等表默认值
    *(MAXKEY-220418) Metadatas功能优化
    *(MAXKEY-220419) 头像保存出错BUG修复 #I4VQDD(无双的英雄peerless_hero)
    *(MAXKEY-220420) 用户资料空值问题修复 #I4VNPO(无双的英雄peerless_hero)
    *(MAXKEY-220421) 增加SERVER_PROFILES，SERVER_PORT，SERVER_SESSION_TIMEOUT的环境参数
    *(MAXKEY-220422) 认证缓存的优化
    *(MAXKEY-220423) 依赖项引用、更新和升级
        spring                   5.3.16
        springBoot               2.6.4
        springSecurity           5.6.2
        springData               2.6.2
        springSession            2.6.2
        springcloud              3.1.1
        commonsvalidator         1.7
        RocketMQclient           4.9.2
        RocketmMQspringboot      2.2.1
        jsoup                    1.14.3
        
MaxKey v 3.3.2 GA 2022/02/17
    *(MAXKEY-220301) 统一界面色调
    *(MAXKEY-220302) 增加飞书扫码登录，更新最新飞书图标
    *(MAXKEY-220303) appList GRID界面优化，增加边框和阴影背景
    *(MAXKEY-220304) appList TABLE界面统一文字对齐，鼠标移动提示背景
    *(MAXKEY-220305) metadata(JWT,OIDC,SAML)调整优化
    *(MAXKEY-220306) 应用管理基本信息折叠效果
    *(MAXKEY-220307) formbased优化，多种密码hash支持
    *(MAXKEY-220308) JWT支持JWK配置
    *(MAXKEY-220309) OAuth支持JWK配置
    *(MAXKEY-220310) CAS,JWT,OIDC,TOKENBASE可配置用户映射
    *(MAXKEY-220311) 应用的过期时间、有效时间统一为Seconds秒
    *(MAXKEY-220312) appList的style调整到css文件中
    *(MAXKEY-220313) 组织管理界面优化
    *(MAXKEY-220314) 用户状态文字调整
    *(MAXKEY-220315) OIDC配置优化，简化配置参数
    *(MAXKEY-220316) JWT 增加jwtName参数
    *(MAXKEY-220317) 适配器优化和调整
    *(MAXKEY-220318) 修复FORMBASE写入用户关联问题
    *(MAXKEY-220319) AD域同步优化，空字段值用默认值替代
    *(MAXKEY-220320) LDAP连接时日志打印密码问题
    *(MAXKEY-220321) 依赖jar引用、更新和升级
        postgresql              42.3.3

MaxKey v 3.3.1 GA 2022/02/10
    *(MAXKEY-220201) 同步器拆分，统一组织在maxkey-synchronizers目录下
    *(MAXKEY-220202) Active Directory同步器优化
    *(MAXKEY-220203) LDAP同步器优化
    *(MAXKEY-220204) 钉钉同步器多组织读取BUG修复
    *(MAXKEY-220205) 新增飞书的同步器
    *(MAXKEY-220206) 修复权限管理的保存错误问题
    *(MAXKEY-220207) 应用扩展属性英文逗号(,)使用ISO8859_1的(#44;)替换，修复多值BUG
    *(MAXKEY-220208) WebXss新增属性过滤，优化URL的过滤
    *(MAXKEY-220209) 修复动态角色、动态组、账号策略显示机构名称的无分隔符问题，统一用逗号分隔
    *(MAXKEY-220210) 删除LDAP连接时日志打印密码问题
    *(MAXKEY-220211) LDAP获取条目的字段的详情信息
    *(MAXKEY-220212) 短信验证码SMS发送优化
    *(MAXKEY-220213) 注册地址改为signup
    *(MAXKEY-220214) 界面风格色调统一
    *(MAXKEY-220215) 登录界面样式的优化
    *(MAXKEY-220216) 依赖jar引用、更新和升级
        tomcat                   9.0.58
        springBoot               2.6.3
        springSecurity           5.6.1
        springData               2.6.1
        springSession            2.6.1
        springkafka              2.8.2
        jbosslogging             3.4.3.Final
        thymeleaf                3.0.14.RELEASE
        springbootadmin          2.6.2
        slf4j                    1.7.35
        jackson                  2.13.1
        woodstox                 6.2.8
        nimbusjosejwt            9.16.1
        JustAuth                 1.16.5

MaxKey v 3.3.0 GA 2022/01/21
    *(MAXKEY-220101) 机构管理配置管理
    *(MAXKEY-220102) 应用系统名称后台配置及国际化支持
    *(MAXKEY-220103) 初步实现国际化存储在数据库
    *(MAXKEY-220104) 租户管理邮箱地址
    *(MAXKEY-220105) 租户管理短信网关
    *(MAXKEY-220106) 租户管理LDAP配置
    *(MAXKEY-220107) 官方网站增加Dromara标识
    *(MAXKEY-220108) LDAP认证从租户读取配置
    *(MAXKEY-220109) 租户管理社交账号
    *(MAXKEY-220110) 社交账号自动识别http,https
    *(MAXKEY-220111) 增加prometheus支持
    *(MAXKEY-220112) 增加find和findOne的方法，可根据where的过滤条件查询数据
    *(MAXKEY-220113) log4j日志pattern调整 
    *(MAXKEY-220114) 数据库方法统一命名
    *(MAXKEY-220115) 修复新增应用oauth2协议 多租户新增bug
    *(MAXKEY-220116) Logger统一使用slf4j
    *(MAXKEY-220117) maxkey-synchronizers-dingding改为maxkey-synchronizers-dingtalk
    *(MAXKEY-220118) org.maxkey.persistence.db调整为org.maxkey.persistence.repository
    *(MAXKEY-220119) org.maxkey.constants下的类统一以Consts开头
    *(MAXKEY-220120) 认证协议返回的数据统一增加机构institution
    *(MAXKEY-220121) 机构institution，使用instid作为租户标识，对应instance(实例)
    *(MAXKEY-220122) 增加mxk_inst cookie，代表当前登录的租户编号
    *(MAXKEY-220123) 修复钉钉同步器bug
    *(MAXKEY-220124) 修复LDAP同步器bug
    *(MAXKEY-220125) 修复企业微信同步器bug
    *(MAXKEY-220126) 增加在线集成指南
    *(MAXKEY-220127) 官方网站更新和优化
    *(MAXKEY-220128) opensaml的jar存放在本地，加速构建的效率
    *(MAXKEY-220129) readme完善
    *(MAXKEY-220130) 依赖jar引用、更新和升级
        log4j           2.17.1
        spring          5.3.15
        springBoot      2.6.1
        springbootadmin 2.6.0
        xmlbeans        5.0.2
        poi             5.1.0
        jedis           3.8.0
        mybatis         3.5.9
        mybatis-jpa-extra 2.7
        
MaxKey v 3.2.0 GA 2021/12/21
    *(MAXKEY-211001) 实现多租户基本功能
    *(MAXKEY-211002) Apache log4j漏洞升级到2.17.0
    *(MAXKEY-211004) 修改对称加密算法，
    *(MAXKEY-211005) OAuth 2.*增加departmentId用户返回属性
    *(MAXKEY-211006) 删除springfox,swagger依赖，增加springdoc依赖
    *(MAXKEY-211007) 删除eclipsePluginApply.bat脚本
    *(MAXKEY-211008) 同步器凭证加密
    *(MAXKEY-211009) 社交账号提供商client_secret加密
    *(MAXKEY-211010) 依赖jar引用、更新和升级
        log4j           2.17.0
        tomcat          9.0.56
        spring          5.3.14
        springBoot      2.6.1
        springSecurity  5.6.0
        springData      2.6.0
        springSession   2.6.0
        springkafka     2.8.0
        springdoc       1.5.13
        springcloud     3.1.0
        guava           31.0.1-jre
        micrometercore  1.8.1
        commonspool2    2.11.1
        swaggerV3       2.1.11
        jedis           3.7.1
        mybatis         3.5.8
    
MaxKey v 3.1.1 GA 2021/11/30
    *(MAXKEY-210901) 腾讯iOA零信任产品适配
    *(MAXKEY-210902) docker部署完善和文档优化
    *(MAXKEY-210903) docker-compose支持和文档
    *(MAXKEY-210904) SCIM2优化
    *(MAXKEY-210905) 机构和用户Excel导入优化
    *(MAXKEY-210906) 认证服务下拉菜单bug修复
    *(MAXKEY-210907) 增加账号策略的功能
    *(MAXKEY-210908) 状态检查management.health.mail.enabled=false
    *(MAXKEY-210909) 图片验证码分离
    *(MAXKEY-210910) 缓存功能优化
    *(MAXKEY-210911) 独立任务MaxKeyMgtJobs
    *(MAXKEY-210912) 管理端左侧菜单问题修复
    *(MAXKEY-210913) 修改WebContext.getBean方法，返回类对象
    *(MAXKEY-210914) 认证失败超过最大次数锁定时间问题修复
    *(MAXKEY-210915) platform.common.js优化
    *(MAXKEY-210916) CAS单点登录符号问题调整
    *(MAXKEY-210917) 接口调用认证拦截优化
    *(MAXKEY-210918) APP加载空问题修复
    *(MAXKEY-210919) OAuth2 token支持GET方法
    *(MAXKEY-210920) OAuth2 client_credentials模式优化
    *(MAXKEY-210921) 依赖jar引用、更新和升级
         spring              5.3.13
         springData          2.5.7
         springkafka         2.7.8
         springbootadmin     2.5.4
         jodatime            2.10.13
         mybatis-jpa-extra   2.6.1
    
MaxKey v 3.1.0 GA 2021/11/03
    *(MAXKEY-210801) OAuth 2.1及PKCE支持
    *(MAXKEY-210802) bootstrap升级到5.1.2
    *(MAXKEY-210803) 缓存切换成Caffeine
    *(MAXKEY-210804) 代码初步兼容JDK 17
    *(MAXKEY-210805) 配置文件参数的整合
    *(MAXKEY-210806) SDK 客户端代码优化
    *(MAXKEY-210807) 官方网站优化
    *(MAXKEY-210808) 界面UI优化
    *(MAXKEY-210809) 下拉菜单优化
    *(MAXKEY-210810) 日志优化
    *(MAXKEY-210811) 密码修改问题修复
    *(MAXKEY-210812) 环境变量参数优化
    *(MAXKEY-210813) 管理端图标显示修复
    *(MAXKEY-210814) 认证系统菜单项调整
    *(MAXKEY-210815) OAuth的数据库加载增加本地缓存
    *(MAXKEY-210816) 社交账号登录改为存储在数据库中，方便用户更改
    *(MAXKEY-210817) 账号策略管理及动态适配
    *(MAXKEY-210818) 社交账号登录过程优化
    *(MAXKEY-210819) 调整了机构显示树的样式
    *(MAXKEY-210820) 企业微信扫码登录js更新wwLogin-1.2.4.js
    *(MAXKEY-210821) 中文切换调整为下拉菜单
    *(MAXKEY-210822) 移除原有的缓存方案
    *(MAXKEY-210823) 应用管理OAuth适配器显示问题修复
    *(MAXKEY-210824) 图片验证码优化，增加随机颜色的字符生成实现，干扰线优化
    *(MAXKEY-210825) 菜单名称的调整
    *(MAXKEY-210826) JS脚本整合优化
    *(MAXKEY-210827) 机构关系映射
    *(MAXKEY-210828) 登录失败信息提示优化
    *(MAXKEY-210829) 机构namepath重组
    *(MAXKEY-210830) HttpRequestAdapter支持JSON
    *(MAXKEY-210831) OAuth2 从客户端引导空指针修复
    *(MAXKEY-210832) Demo问题修复
    *(MAXKEY-210833) 依赖jar引用、更新和升级
         spring              5.3.12
         springboot          2.5.6
         tomcat              9.0.54
         springSecurity      5.5.3
         springData          2.5.5
         springSession       2.5.3
         mybatis-jpa-extra   2.6
         druid               1.2.8
         caffeine            2.9.2
         jaxbcore            3.0.2
         jaxbimpl            3.0.2
         jaxbxjc             3.0.2

MaxKey v 3.0.0 GA 2021/09/29
    *(MAXKEY-210701) 好雨科技Rainbond适配，实现基于Rainbond应用商店的快速部署
    *(MAXKEY-210702) 制定MaxKey技术路线图
    *(MAXKEY-210703) CHINER元数建模构建MaxKEY ER模型完善，数据库字段说明完善
    *(MAXKEY-210704) Nacos配置中心支持，可选支持本地和Nacos配置中心配置，配置更加灵活
    *(MAXKEY-210705) springcloud &springcloud alibaba微服务支持
    *(MAXKEY-210706) spring cloud gateway支持
    *(MAXKEY-210707) application.properties参数调整和优化，支持外部Docker及环境变量的配置
    *(MAXKEY-210708) 同步器定时任务功能优化
    *(MAXKEY-210709) mgt增加会话管理功能
    *(MAXKEY-210710) mgt报表功能优化
    *(MAXKEY-210711) SAML ID调整为MXK_开头，修复类型匹配的bug，增加常用的用户字段
    *(MAXKEY-210712) JWT单点登录的权限控制，修复bug
    *(MAXKEY-210713) Gradle升级7.2
    *(MAXKEY-210714) Gradle 标准、JAR、Docker编译打包脚本优化
    *(MAXKEY-210715) Shell启动脚本优化
    *(MAXKEY-210716) 新增MySql Docker支持及初始化脚本
    *(MAXKEY-210717) Readme优化，增加MaxKey Docker的仓库地址
    *(MAXKEY-210718) 产品介绍pdf的优化
    *(MAXKEY-210719) mgt批量删除的优化
    *(MAXKEY-210720) Jira SAML集成指南
    *(MAXKEY-210721) 官方网站内容的优化，增加同类产品的比较，用户构建指南，完善集成应用列表
    *(MAXKEY-210722) 日志信息的完善，包括登录过程日志，初始化日志，单点登录日志等
    *(MAXKEY-210723) mgt登录错误提示信息
    *(MAXKEY-210724) 警告提示信息修复
    *(MAXKEY-210725) 工具类增强和优化
    *(MAXKEY-210726) 登录认证优化，增加密码策略应用和验证
    *(MAXKEY-210727) CAS登录中参数回传的修复，增加'#'停止符的优化
    *(MAXKEY-210728) StringUtils优化，直接继承org.apache.commons.lang3.StringUtils，增加自有逻辑
    *(MAXKEY-210729) 依赖jar引用、更新和升级
        spring              5.3.10
        springBoot          2.5.5
        springkafka         2.7.7
        spring-cloud        3.0.4
        springcloudalibabacspl 1.8.2
        mybatis-jpa-extra   2.5
        tomcat              9.0.53
        kafkaclients        2.8.1
        jibGradlePlugin     3.1.4
        gson                2.8.8
        mysqlconnector      8.0.26
        jedis               3.7.0
        ehcache             3.9.6
        nacos               2.0.3
        jacksonVersion      2.12.5
        httpasyncclient     4.1.4
        bouncycastle        1.69
        JustAuth            1.16.4
    
MaxKey v 2.9.0 GA 2021/08/24
    *(MAXKEY-210601) 企业微信扫描登录
    *(MAXKEY-210602) 钉钉扫描登录
    *(MAXKEY-210603) 第三方登录异常问题修复
    *(MAXKEY-210604) 新建maxkey-webs目录，包含maxkey-web-maxkey、maxkey-web-mgt、maxkey-web-resources、maxkey-boot-monitor
    *(MAXKEY-210605) 静态文件的合并到maxkey-web-resources
    *(MAXKEY-210606) 腾讯企业邮箱适配器优化
    *(MAXKEY-210607) 移除*.xml的spring配置文件
    *(MAXKEY-210608) 后台管理员自动生成密码的问题修复
    *(MAXKEY-210609) 密码重置接口的优化
    *(MAXKEY-210610) KAFKA数据同步接口优化，重新定义同步TOPIC
    *(MAXKEY-210611) LDAP及ActiveDirectory属性和连接的优化
    *(MAXKEY-210612) Synchronizers同步器的模块化，分成activedirectory、ldap、dingding、workweixin
    *(MAXKEY-210613) Synchronizers增加定时同步功能
    *(MAXKEY-210614) 后台用户和机构查询排序优化
    *(MAXKEY-210615) 增加连接器日志查询
    *(MAXKEY-210616) 增加同步器日志查询
    *(MAXKEY-210617) 应用配置适配器不生效修复
    *(MAXKEY-210618) FormBased认证功能的优化
    *(MAXKEY-210619) FormBased密码首次初始化问题修复
    *(MAXKEY-210620) 重新登录地址优化
    *(MAXKEY-210621) 实体类型的ID全部调整为雪花ID
    *(MAXKEY-210622) 后台报表优化
    *(MAXKEY-210623) 底层数据库mybatis-jpa-extra优化及问题修复
    *(MAXKEY-210624) 登录模块的模块化
    *(MAXKEY-210625) LDAP登录成功，密码自动同步到MaxKey
    *(MAXKEY-210626) 社交账号企业微信LOGO
    *(MAXKEY-210627) 找回密码时密码不匹配问题修复
    *(MAXKEY-210628) SHELL脚本优化
    *(MAXKEY-210629) 官方网站优化
    *(MAXKEY-210630) 标准构建优化
    *(MAXKEY-210631) maxkey-web-mgt配置文件分离，方便后续不同环境的切换
    *(MAXKEY-210632) 密码过期，当密码错误时，跳转到密码过期页面错误问题，流程：密码验证正确，然后跳转密码过期界面
    *(MAXKEY-210633) 登录密码错误n次,n小于设定的次数，后一次登录密码正确，设置密码错误次数为0
    *(MAXKEY-210634) CAS参数优化及认证参数bug修复
    *(MAXKEY-210635) Redis集群时OAUTH2登录Approval空值bug修复
    *(MAXKEY-210636) maxkey-boot-monitor Spring Boot Admin服务监控 
    *(MAXKEY-210637) 用户会话管理及优化
    *(MAXKEY-210638) 会话结束事件监听控制管理
    *(MAXKEY-210639) 定时任务功能优化
    *(MAXKEY-210640) 登录时间，注销时间等相关时间不一致修复
    *(MAXKEY-210641) 统一用户在线会话ID和在线令牌
    *(MAXKEY-210642) 字段uid统一改为userid
    *(MAXKEY-210643) CHINER元数建模ER模型设计
    *(MAXKEY-210644) 依赖jar引用、更新和升级
        spring              5.3.9
        springBoot          2.5.4
        springSession       2.5.2
        springSecurity      2.5.2
        springData          2.5.2
        springkafka         2.7.6
        JustAuth            1.16.3
        kafkaclients        2.6.2
        tomcat              9.0.52
        gson                2.8.7
        jbosslogging        3.4.2.Final
        hibernate           7.0.1.Final
        swaggerV3           2.1.10
        knife4j             3.0.3
        druid               1.2.6
        jedis               3.6.3
        ehcache             3.9.5
        slf4j               1.7.32
        jackson             2.12.4
        fastjson            1.2.78
        jodatime            2.10.10
        snakeyaml           1.29
        mybatis-jpa-extra   2.4
        
        
MaxKey v 2.8.1 GA 2021/06/25
    *(MAXKEY-210501) 官方网站内容优化
    *(MAXKEY-210502) 修复同步器LDAP保存保存问题
    *(MAXKEY-210503) ReadMe内容优化
    *(MAXKEY-210504) 依赖jar引用、更新和升级
        spring          5.3.8
        springBoot      2.5.1
        springSecurity  5.5.1
        JustAuth        1.16.1

MaxKey v 2.8.0 GA 2021/06/18
    *(MAXKEY-210401) 国产数据库瀚高DB的适配
    *(MAXKEY-210402) 增加手机登录功能，用户可获取手机验证码完成登录
    *(MAXKEY-210403) 同步器支持，定义标准的机构和用户接口，方便其他系统同步机构和用户信息
    *(MAXKEY-210404) Microsoft Active Directory 机构和用户同步支持
    *(MAXKEY-210405) 标准LDAP协议服务器机构和用户同步支持
    *(MAXKEY-210406) Gradle 7支持
    *(MAXKEY-210407) 数据库底层适配优化支持，id采用雪花算法
    *(MAXKEY-210408) 用户注册功能优化，修复脚本错误
    *(MAXKEY-210409) 登录界面优化及调整
    *(MAXKEY-210410) 单点登录认证页面及脚本整合及优化
    *(MAXKEY-210411) 登录超时退出优化
    *(MAXKEY-210412) org.maxkey.domain调整为org.maxkey.entity
    *(MAXKEY-210413) 数据查询SQL语句改成小写
    *(MAXKEY-210414) OAuth2.0单点登录确认界面配置优化
    *(MAXKEY-210415) 应用配置保存时logoutUrl和logoutType丢失修复
    *(MAXKEY-210416) 同步器历史同步日志审计功能
    *(MAXKEY-210417) 删除json2form插件，优化CSS，整合javacript脚本
    *(MAXKEY-210418) 增加用户状态USERSTATE的属性（在职、退休、离职等），status用做活动/锁定/禁用等状态
    *(MAXKEY-210419) 分离角色权限管理模块，未来和其他系统集成适配，实现权限的统一管理
    *(MAXKEY-210420) 模板布局优化及段落注释说明
    *(MAXKEY-210421) 优化启动脚本，解决长度过长问题
    *(MAXKEY-210422) 构建时依赖问题修复
    *(MAXKEY-210423) 官方网站优化，修复有误内容
    *(MAXKEY-210424) 项目使用jars的版本及协议的更新
    *(MAXKEY-210425) 依赖jar的版本统一配置gradle.properties
    *(MAXKEY-210426) 依赖jar引用、更新和升级
        spring 5.3.8
        springBoot 2.5.1
        springSecurity 5.5.0
        tomcat 9.0.46
        jibGradle 2.7.1
        springData 2.5.1
        springSession 2.5.0
        druid 1.2.5
        jedis 3.6.0
        mybatis 3.5.7

﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿MaxKey v 2.8.0 RC1  2021/06/01
    *(MAXKEY-210401)  国产数据库瀚高DB的适配
    *(MAXKEY-210402)  增加手机登录功能，用户可获取手机验证码完成登录
    *(MAXKEY-210403)  同步器支持，定义标准的机构和用户接口，方便其他系统同步机构和用户信息
    *(MAXKEY-210404)  Microsoft Active Directory 机构和用户同步支持
    *(MAXKEY-210405)  标准LDAP协议服务器机构和用户同步支持
    *(MAXKEY-210406)  Gradle 7支持
    *(MAXKEY-210407)  数据库底层适配优化支持，id采用雪花算法
    *(MAXKEY-210408)  用户注册功能优化，修复脚本错误
    *(MAXKEY-210409)  登录界面优化及调整
    *(MAXKEY-210410)  单点登录认证页面及脚本整合及优化
    *(MAXKEY-210411)  登录超时退出优化
    *(MAXKEY-210412)  org.maxkey.domain调整为org.maxkey.entity
    *(MAXKEY-210413)  数据查询SQL语句改成小写
    *(MAXKEY-210414)  OAuth2.0单点登录确认界面配置优化
    *(MAXKEY-210415)  应用配置保存时logoutUrl和logoutType丢失修复
    *(MAXKEY-210416)  同步器历史同步日志审计功能
    *(MAXKEY-210417)  删除json2form插件，优化CSS，整合javacript脚本
    *(MAXKEY-210418)  增加用户状态USERSTATE的属性（在职、退休、离职等），status用做活动/锁定/禁用等状态
    *(MAXKEY-210419)  分离角色权限管理模块，未来和其他系统集成适配，实现权限的统一管理
    *(MAXKEY-210420)  模板布局优化及段落注释说明
    *(MAXKEY-210421)  优化启动脚本，解决长度过长问题
    *(MAXKEY-210422)  构建时依赖问题修复
    *(MAXKEY-210423)  依赖jar的版本统一配置gradle.properties
    *(MAXKEY-210424)  依赖jar引用、更新和升级
        spring          5.3.7
        springBoot      2.4.5
        springSecurity  5.5.0
        tomcat          9.0.46
        jibGradle       2.7.1
        springData      2.5.1
        springSession   2.5.0
        druid           1.2.5
        jedis           3.6.0
        mybatis         3.5.7

MaxKey v 2.7.0 GA   2021/04/15
    *(MAXKEY-210301)  加入Dromara开源组织，官方网站的优化，文档优化
    *(MAXKEY-210302)  BootJar，Docker，Standard三种打包方式的配置优化
    *(MAXKEY-210303)  openldap,activedirectory密码验证支持
    *(MAXKEY-210304)  数据库访问注释由@Service改为@Repository
    *(MAXKEY-210305)  cas logout优化支持
    *(MAXKEY-210306)  CAS单点注销及返回数据类型适配器的优化
    *(MAXKEY-210307)  CAS返回数据类重构
    *(MAXKEY-210308)  CAS地址优化统一配置到常量类CasConstants
    *(MAXKEY-210309)  注销空指针异常BUG
    *(MAXKEY-210310)  OAuth2地址优化统一配置常量类OAuth2Constants
    *(MAXKEY-210311)  OAuth2 Token多次调用时认证转换的BUG
    *(MAXKEY-210312)  ExtendApi标准优化
    *(MAXKEY-210313)  增加基于时间签名的ExtendApi适配器
    *(MAXKEY-210314)  返回数据Constants整合
    *(MAXKEY-210315)  扩展数据配置优化
    *(MAXKEY-210316)  LDAP和MS AD固定属性Constants
    *(MAXKEY-210317)  SpringSecurity OAuth 2客户端登录适配
    *(MAXKEY-210318)  移除Desktop的支持，后续可以开发FormBase的适配器定制
    *(MAXKEY-210319)  application.properties profiles的优化，不同环境启动更加简单
    *(MAXKEY-210320)  删除maxkey.properties，配置整合到 application.properties
    *(MAXKEY-210321)  增加适配器注册功能，在配置应用时只需选择对应的适配器
    *(MAXKEY-210322)  增加Synchronizer接口同步的功能
    *(MAXKEY-210323)  增加TimeBased OTP接口支持
    *(MAXKEY-210324)  XSS安全防护功能
    *(MAXKEY-210325)  禅道项目管理系统单点登录适配
    *(MAXKEY-210326)  GitLab单点登录适配
    *(MAXKEY-210327)  云速邮箱单点登录适配
    *(MAXKEY-210328)  JumpServer开源堡垒机单点登录适配
    *(MAXKEY-210329)  华为云单点登录适配
    *(MAXKEY-210330)  Jenkins单点登录适配
    *(MAXKEY-210331)  通知公告简单功能实现
    *(MAXKEY-210332)  查询参数优化
    *(MAXKEY-210333)  SDK优化
    *(MAXKEY-210334)  依赖jar引用、更新和升级
        log4j       2.14.1
        spring      5.3.6
        springBoot  2.4.4
        springSecurity 5.4.6
        tomcat      9.0.44
    
MaxKey v 2.6.0 GA   2021/03/05
    *(MAXKEY-210201)  官方网站的优化
    *(MAXKEY-210202)  CAS代理模式实现的优化，完成demo的测试
    *(MAXKEY-210203)  CAS代理模式Demo开发和实现
    *(MAXKEY-210204)  LINUX版安装指南优化，升级MySQL到8.0
    *(MAXKEY-210205)  构建优化，实现自动打包到Build Release
    *(MAXKEY-210206)  springboot-actuator优化
    *(MAXKEY-210207)  登录模式的拆分和整合
    *(MAXKEY-210208)  模块的重组和优化，拆分出通用模块maxkey-common，captcha，otp，social等
    *(MAXKEY-210209)  REST API优化,增加密码修改功能
    *(MAXKEY-210210)  session及cookie参数的优化
    *(MAXKEY-210211)  kafka供应服务移动到org.maxkey.persistence.kafka
    *(MAXKEY-210212)  用户注册功能优化
    *(MAXKEY-210213)  日志信息输出优化
    *(MAXKEY-210214)  简化MaxKey banner输出
    *(MAXKEY-210215)  token工厂模式的实现Factorys
    *(MAXKEY-210216)  OTP的优化
    *(MAXKEY-210217)  MapperScan重复优化
    *(MAXKEY-210218)  maxkey-mgt端口号调整9527,wiki端口号调整9521
    *(MAXKEY-210219)  依赖jar引用、更新和升级
        spring           5.3.4
        springBoot       2.4.3
        springSecurity   5.4.5
        tomcat           9.0.41
        freemarker       2.3.31
        kafka-clients    2.6.1
        spring-kafka     2.6.6
        micrometer       1.6.4
        latencyutils     2.0.3
        stax2-api        4.2.1
        druid            1.2.5
        

MaxKey v 2.5.0 GA   2021/02/05
    *(MAXKEY-210101)  动态用户组实现优化，增加时间段控制
    *(MAXKEY-210102)  官方网站优化，取消加载动态图表；增加统计功能
    *(MAXKEY-210103)  优化社交登录的图标
    *(MAXKEY-210104)  社交账号支持Gitee和微信
    *(MAXKEY-210105)  社交账号绑定列表化，显示绑定时间和最近登录时间，绑定的操作，支持多个OAuth第三方，参见JustAuth
    *(MAXKEY-210106)  语言选择位置调整
    *(MAXKEY-210107)  短信验证码存储Redis修复
    *(MAXKEY-210108)  OAuthDetail修复Visible
    *(MAXKEY-210109)   镜像加速gradle默认使用阿里云aliyun 
    *(MAXKEY-210110)  Swagger文档支持 maxkey/swagger-ui/index.html#/
    *(MAXKEY-210111)  knife4j文档支持 maxkey/doc.html
    *(MAXKEY-210112)  登录界面加密处理
    *(MAXKEY-210113)   依赖jar引用、更新和升级
        spring      5.3.3
        springBoot  2.4.2
        jedis       3.4.1
        druid       1.2.4
        JustAuth    1.15.9
        joda-time   2.10.9
        zxing       3.4.1
        jackson     2.12.1
        guava       30.1-jre
        mybatis     3.5.6
        mybatis-spring  2.0.6
        hibernate   6.2.0.Final
        jibGradlePlugin 2.7.0
        nimbus-jose-jwt 9.4.1
        tomcat-embed-core   9.0.41
        swagger     1.6.2
        swagger3    2.1.6
        springfox   3.0.0
        knife4j     3.0.2
    
MaxKey v 2.4.0 GA   2021/01/01
    *(MAXKEY-201001)  动态用户组实现(基于用户属性或机构)
    *(MAXKEY-201002)  任职机构和兼职机构
    *(MAXKEY-201003)  登录会话切换的优化
    *(MAXKEY-201004)  我的应用界面隐藏visible = 0的应用
    *(MAXKEY-201005)  构建脚本的优化和更新
    *(MAXKEY-201006)  全新的版本号定义，正式版本jar不再添加 RELEASE 后缀声明，author由shimingxy改为maxkeyTop
    *(MAXKEY-201007)  SAML2.0 SP登录引导的优化
    *(MAXKEY-201008)  SAML2.0 SP DEMO,案例参见 https://github.com/MaxKeyTop/spring-boot-security-saml-sample
    *(MAXKEY-201009)  docker支持的优化
    *(MAXKEY-201010)  源代码增加LICENSE声明
    *(MAXKEY-201011)  JWT的分离成protocols下子项目
    *(MAXKEY-201012)  密码策略提示参数问题修复
    *(MAXKEY-201013)  SAML 2.0 Metadata优化
    *(MAXKEY-201014)  HandlerInterceptorAdapter@deprecated  调整为 AsyncHandlerInterceptor 
    *(MAXKEY-201015)  mybatis-jpa升级，添加@Entity和@Transient支持，优化update时字段为null的处理，SQL代码优化 
    *(MAXKEY-201016)  README更新及中文和英文支持
    *(MAXKEY-201017)  认证失败时，authentication 空指针异常
    *(MAXKEY-201018)  SAML Metadata URL配置读取
    *(MAXKEY-201019)  添加组和角色时按登录名查询成员
    *(MAXKEY-201020)  firefox点击验证码无更新修复
    *(MAXKEY-201021)  官网内容更新
    *(MAXKEY-201022)  管理MGT样式调整优化
    *(MAXKEY-201023)  OAuth2.0 password认证失败是返回异常问题
    *(MAXKEY-201024)  OAuth2.0 password获取用户信息，类型无法转换错误
    *(MAXKEY-201025)  依赖jar引用、更新和升级
        not-yet-commons-ssl 0.3.9
        log4j               2.14.0
        spring              5.3.2
        springBoot          2.4.1
        springSecurity      5.4.1
        springData          2.4.1
        springSession       2.4.1
        mybatis-jpa-extra   2.2
        opensaml            2.6.6
        

MaxKey v 2.3.0 GA   2020/11/12
    *(MAXKEY-200901)  基于spring session的集群会话共享功能 
    *(MAXKEY-200902) 单点注销功能，应用可以配置为NONE/BACK_CHANNEL/FRONT_CHANNEL三种方式，支持CAS/SAML/Default
    *(MAXKEY-200903)  用户在线实时更新功能
    *(MAXKEY-200904)  定制用户模板，实现批量Excel用户导入功能
    *(MAXKEY-200905)   定制机构模板，实现批量Excel机构导入功能
    *(MAXKEY-200906)  用户注册功能
    *(MAXKEY-200907)  用户状态修改
    *(MAXKEY-200908)  用户详情显示问题
    *(MAXKEY-200909)  应用修改时数字大于4为长度格式化问题
    *(MAXKEY-200910)  注销后，点击重新登陆跳转问题
    *(MAXKEY-200911)  增加SP登录跳转功能，支持knox的认证
    *(MAXKEY-200912)  构建脚本的优化和更新
    *(MAXKEY-200913)  管理员权限控制 RoleAdministrators 
    *(MAXKEY-200914)  社交账号登录优化
    *(MAXKEY-200915)  列表界面中未”选择“情况下，弹出界面错误
    *(MAXKEY-200916) jib(docker) 支持 ，感谢https://github.com/alanland
    *(MAXKEY-200917)  登录过程的优化
    *(MAXKEY-200918)  认证的优化，支持@Principal的注入
    *(MAXKEY-200919) 应用单点登录时，用户访问权限控制
    *(MAXKEY-200920) maxkey-mgt 项目配置文件的验证码启用不启用配置未生效
    *(MAXKEY-200921) 登录图标改进
    *(MAXKEY-200922)  官方网站的优化
    *(MAXKEY-200923)  依赖jar引用、更新和升级
        druid 1.2.1
        JustAuth 1.15.8
        simple-http 1.0.3
        spring-session 2.3.1.RELEASE
        druid-spring-boot-starter 1.2.1
        xmlbeans  3.0.1
        commons-compress 1.20
        poi 4.1.2
        commons-collections4 4.4
 
MaxKey v 2.2.0 GA   2020/09/24
    *(MAXKEY-200801)  官方网站内容调整，初步增加英文版支持，增加新闻、合作伙伴及与CAS等开源产品对比
    *(MAXKEY-200802)  国际化I18N内容优化
    *(MAXKEY-200803)  使用Passay增强密码策略，分离静态密码策略和动态密码策略
    *(MAXKEY-200804)  修复登录失败的提示消息，支持国际化
    *(MAXKEY-200805)  密码@Deprecated从spring移到maxkey并去掉@Deprecated
    *(MAXKEY-200806)  默认管理员登录名和密码admin/maxkey
    *(MAXKEY-200807)  优化密码修改的过程，增加密码策略匹配及提示消息
    *(MAXKEY-200808)  密码错误次数大于6次后，超过设定时间自动解锁
    *(MAXKEY-200809)  修复初始化密码和密码过期修改后错误问题
    *(MAXKEY-200810)  修复SHAREDSECRET为空令牌显示报错
    *(MAXKEY-200811)  登录代码优化与整合
    *(MAXKEY-200812)  优化开发集成指南
    *(MAXKEY-200813)  删除冗余的文件和文件夹
    *(MAXKEY-200814)  优化应用适配器支持
    *(MAXKEY-200815)  Maven版本支持
    *(MAXKEY-200816)  CAS REST-Protocol支持及客户端demo
    *(MAXKEY-200817)  修复CAS返回参数为空时BASE64编码报错
    *(MAXKEY-200818)  修复CAS SERVICE参数过长的不一致问题，截取与数据参数等长，然后比较
    *(MAXKEY-200819)  CAS协议增加自定义参数回传
    *(MAXKEY-200820)  CAS spring boot demo
    *(MAXKEY-200821)  MGT管理访问找不到页面修复
    *(MAXKEY-200822)  MGT管理密码修改增加自动密码生成
    *(MAXKEY-200823)  优化TOKENBASED令牌内容的配置
    *(MAXKEY-200824)  修复OAuth 2.0管理端的跳过确认提示不能修改
    *(MAXKEY-200825)  应用管理修改时关闭修正
    *(MAXKEY-200826)  MGT管理首页统计优化
    *(MAXKEY-200827)  审计查询功能优化
    *(MAXKEY-200828)  修复日期控件显示问题
    *(MAXKEY-200829)  SCIM 2服务端功能优化
    *(MAXKEY-200830)  注销时的跳转修复
    *(MAXKEY-200831)  MySQL时间问题，参见https://dev.mysql.com/doc/refman/8.0/en/time-zone-support.html
    *(MAXKEY-200832)  OAuth2 Password模式修复
    *(MAXKEY-200833)  MGT管理SAML上传问题、IDP元数据链接优化、主键生成修复、元数据参数配置调整
    *(MAXKEY-200834)  SAML 2添加多种NameId的支持，支持后缀的配置，NameId支持大小写转换
    *(MAXKEY-200835)  MGT管理TOKENBASED令牌主键生成修复
    *(MAXKEY-200836)  依赖jar升级
                        tomcat 9.0.38
                        passay 1.6.0
                        springBootVersion  2.3.4.RELEASE
                        springVersion   5.2.9.RELEASE
                        springSecurityVersion   5.4.0
                        guava  29.0-jre
                        joda-time 2.10.6
                        ehcache 3.9.0
                        alibaba druid 1.1.24
                        fastjson 1.2.73
                        jackson 2.11.2
                        tink 1.4.0
                        JustAuth 1.15.7
                        nimbus-jose-jwt 9.0.1
                        commons-lang3 3.11
                        commons-io 2.8.0
                        commons-codec 1.15
                        hibernate   6.1.5.Final
                        multiple-select-1.5.2
    
    
MaxKey v 2.1.0 GA   2020/08/01
    *(MAXKEY-200701)  官方网站升级，清晰简洁的界面，全新的页面导航
    *(MAXKEY-200702) Mysql升级到8.0.21GA
    *(MAXKEY-200703) MaxKey认证服务手机支持
    *(MAXKEY-200704)   取消MaxKey认证系统双端口的启动，解决登录时session不一致问题
    *(MAXKEY-200705)   强化密码验证的功能，适配多种密码结构
    *(MAXKEY-200706) RBAC权限功能增强，支持多种资源类型
    *(MAXKEY-200707) Connector连接器从主项目分离，专注与KAFKA的适配
    *(MAXKEY-200708) SDK主项目分离，增加用户管理API适配功能
    *(MAXKEY-200709)  依赖jar升级,消除非必要依赖
                    spring 5.2.8.RELEASE
                    springBoot 2.3.2.RELEASE
                    MySql  8.0.21GA
                    
                    
MaxKey v 2.0.0 GA   2020/07/13 
    *(MAXKEY-200601) RBAC 基于角色的访问控制(Role-Based Access Control)支持
    *(MAXKEY-200602) xml配置改为Spring annotation，提升模块间的组件化
    *(MAXKEY-200603) 管理MGT界面优化及增加菜单图标，认证Maxkey主题切换支持-黑色经典|薄荷清新|激情紫荆
    *(MAXKEY-200604) 修复用户组访问权限删除问题
    *(MAXKEY-200605) Javascript验证及AJAX提交优化
    *(MAXKEY-200606) DAO层整合
    *(MAXKEY-200607) 社交账号关联调整及优化
    *(MAXKEY-200608) 数据库表字段的注释修复
    *(MAXKEY-200609) 官方网站优化
    *(MAXKEY-200610) properties优化
    *(MAXKEY-200611) 访问控制修复，访问重定向的问题修复
    *(MAXKEY-200612) String类型数据转换JSON修复
    *(MAXKEY-200613) OAuth2授权页面优化，显示目标系统图标和相关授权提示
    *(MAXKEY-200614) OAuth2 secret修改后登陆错误修复
    *(MAXKEY-200615) CAS单点登陆后进行验证空指针的异常处理，原因权限调整
    *(MAXKEY-200616) LINUX操作系统支持
    *(MAXKEY-200617) 修改测试域名为sso.maxkey.top
    *(MAXKEY-200618) 修复更新应用时状态问题
    *(MAXKEY-200619) REST API 机构和用户接口实现
    *(MAXKEY-200620) 代码优化及命名调整
    *(MAXKEY-200621) CAS协议增强
    *(MAXKEY-200622) 机构变更时JSON序列化错误修复
    *(MAXKEY-200623) 官方网站、SDK、连接器Connectors分离成独立项目
    *(MAXKEY-200624) 依赖jar升级,消除非必要依赖
                    spring 5.2.7.RELEASE
                    springBoot 2.3.1.RELEASE
                    springSecurity 5.3.2.RELEASE
                    jackson  2.11.0
                    log4j 2.13.3
                    font-awesome 4.7.0
                    tomcat-embed 9.0.35
                    mybatis 3.5.5
                    mybatis-jpa-extra 2.1
                    tomcat-embed 9.0.36
                    simple-http 1.0.2
                    JustAuth  1.15.6
    
MaxKey v 1.4.0 GA   2020/05/01  
    *(MAXKEY-200501) 登录错误修复
    *(MAXKEY-200502) 登录无验证码登录
    *(MAXKEY-200503) 短信验证码SMS
                        腾讯云短信验证码
                        阿里云短信验证码
                        网易云信验证码
    *(MAXKEY-200504) 找回密码，支持邮件找回和短信找回
    *(MAXKEY-200505) 验证增强，增加算术验证码支持
                        config/applicationConfig.properties
                        #text字符验证码,arithmetic算术验证码
                        config.login.captcha.type=text
    *(MAXKEY-200506) 修复新增用户时错误
    *(MAXKEY-200507) 修复操作日志错误
    *(MAXKEY-200508) 修改应用添加错误，增加不为空验证功能
    *(MAXKEY-200509) 用户组增加不为空验证功能
    *(MAXKEY-200510) 机构增加不为空验证功能,排序显示
    *(MAXKEY-200511) 国际化操作提示
    *(MAXKEY-200512) SAML2.0增加签名和摘要配置
    *(MAXKEY-200513) 优化界面，强化提交表单验证功能
    *(MAXKEY-200514) 官方地址域名解析www.maxkey.top
    *(MAXKEY-200515) 组件版本升级
                        mybatis-jpa-extra v2.0
                        JustAuth 1.15.1
                        log4j 2.13.2
                        bootstrap 4.4.1
                        bootstrap-table v1.16.0
                        jquery 3.5.0

MaxKey v 1.3.0 GA   2020/04/04  
    *(MAXKEY-200401) 记住登录修复，RememberMe fix
    *(MAXKEY-200402) 应用账号配置修复
    *(MAXKEY-200403) 内部缓存使用改用ehcache，同时支持redis
    *(MAXKEY-200404) 社交账号登录使用JustAuth 1.14.0，支持更多的第三方社交集成
    *(MAXKEY-200405) 代码使用checkstyle
    *(MAXKEY-200406) 完善gradle编译脚本，并升级到gradle-6.0
    *(MAXKEY-200407) 依赖jar升级,消除非必要依赖
                        spring->5.2.5.RELEASE,
                        springBoot->2.2.6.RELEASE
                        mybatis->3.5.4
                        log4j->2.13.1
                        httpcomponents->4.5.12
    *(MAXKEY-200408) 其他漏洞修正

MaxKey v 1.2.1 GA   2020/02/29   
    *(MAXKEY-200201) SAML 2.0 optimization,support 阿里云、腾讯云 SSO
    *(MAXKEY-200202) maxkey-mgt main report
    *(MAXKEY-200203) APPS ExtraAttr
    *(MAXKEY-200204) fix ui bugs
    *(MAXKEY-200205) remove maxkey-jose-jwt
    *(MAXKEY-200206) dep com.nimbusds nimbus-jose-jwt
    *(MAXKEY-200207) dep net.jcip jcip-annotations
    *(MAXKEY-200208) dep net.minidev json-smart
    *(MAXKEY-200209) dep net.minidev asm 
    
MaxKey v 1.2.0 GA   2020/01/18 
    *(MAXKEY-200101) 升级到bootstrap-4.3.1
    *(MAXKEY-200102) 升级表格为Bootstrap Table 1.14.2
    *(MAXKEY-200103) 升级js树插件到zTree-v3.5.40
    *(MAXKEY-200104) 菜单组件升级为metisMenu-v3.0.4
    *(MAXKEY-200105) 修复系统错误
    *(MAXKEY-200105) 修复日志的输出
    
MaxKey v 1.0 GA     2019/12/06  
    *(MAXKEY-191201) 基于SpringBoot重新构建1.0 GA 
